#!/bin/bash 
###
# VBrowser startup script. 
# P.T. de Boer
#

##
# settings 
#

##
# VLET_SYSCONFDIR 
# Set the following variable when the configuration files or NOT under $VLET_INSTALL/etc ! 
# This is automaticaly done when performing a binary installation 
#VLET_SYSCONFDIR=/etc/vlet

##
# VLET_INSTALL 
# bootstrap startup directory:
if [ -n  "$VLET_INSTALL" ] ; then 
	BASE_DIR="$VLET_INSTALL"
else
	# Dynamically check basedir of installation. Assume script is started from $VLET_INSTALL/bin
	DIRNAME=`dirname "$0"`
	BASE_DIR=`cd "$DIRNAME"/.. ; pwd`
fi

# default sysconfdir, use BASE_DIR/etc 
if [ -z "$VLET_SYSCONFDIR" ] ; then 
	VLET_SYSCONFDIR=$BASE_DIR/etc 
fi

# source installation settings: 
if [ -f "$VLET_SYSCONFDIR/vletenv.sh" ] ; then 
   source "$VLET_SYSCONFDIR/vletenv.sh"
else
   echo "*** Error: couldn't find VLET configuration files."
   # continue with defaults ? 
fi

###
# Startup 
#

#default startup command line: currenlty none:

if [ -z "$@" ] ;then
  echo "No arguments"
  # start with userhome
  #OPTS="file://$HOME" 
  #if [ $cygwin == "true" ] ; then 
  #   OPTS="file://"`cygpath -m $HOME` 
  #fi
else
  OPTS="$@"
fi

# explicit exports

export VLET_INSTALL VLET_SYSCONFDIR 

###
# default classpath:
#

echo "VLET_INSTALL    ="$VLET_INSTALL 
echo "VLET_SYSCONFDIR ="$VLET_SYSCONFDIR 
echo "JAVA_HOME       ="$JAVA_HOME 
echo "CLASSPATH       ="$CLASSPATH
echo "VBROWSER_JAR    ="$VBROWSER_JAR
echo "Command line options ="$OPTS

# bootstrap class set's up real enviromment: 
echo "$JAVA" -cp $CLASSPATH -Dvlet.install.sysconfdir=$VLET_SYSCONFDIR -jar $VBROWSER_JAR $OPTS
"$JAVA" -cp "$CLASSPATH" -Dvlet.install.sysconfdir="$VLET_SYSCONFDIR" -jar "$VBROWSER_JAR" $OPTS

